			// frac.h
#ifndef  _fraction_H
#define  _fraction_H

// choose from: ASSERT_YES (default), NOERROR_TRAP, EXCEPTION
#define ASSERT_YES

#include <iostream.h>
#include <assert.h>     // for macro assert()

class fraction;
typedef fraction fract;
typedef fraction frac;

class fraction
{
   friend ostream& operator<<(ostream&, const fraction&);
   friend istream& operator>>(istream&, fraction&);

   friend fraction operator+(const fraction&, const fraction&);
   friend fraction operator-(const fraction&, const fraction&);
   friend fraction operator*(const fraction&, const fraction&);
   friend fraction operator/(const fraction&, const fraction&);
   friend bool operator<(const fraction&, const fraction&);
   friend bool operator<=(const fraction&, const fraction&);
   friend bool operator>(const fraction&, const fraction&);
   friend bool operator>=(const fraction&, const fraction&);
   friend bool operator==(const fraction&, const fraction&);
   friend bool operator!=(const fraction&, const fraction&);

public:
   #ifdef EXCEPTION
      // exceptions //
      class DivisionBy0 {};
   #endif

   // constructors //
   fraction(): _num(0), _denom(1) {}
   fraction(long n, long d=1): _num(n), _denom(d)
      { ExceptionIfDenom0(); reduce(); }

   // accessors //
   long num() const { return _num; }
   long denom() const { return _denom; }
   void set_num(long n) { _num=n; reduce(); }
   void set_denom(long d)
      { _denom=d; ExceptionIfDenom0(); reduce(); }

protected:
   long _num, _denom;

   void ExceptionIfDenom0()
   {
      #ifdef EXCEPTION
         if (_denom==0) throw DivisionBy0( );
      #elif defined(NOERROR_TRAP)
         // don't trap this error!
      #else // ASSERT_YES
         assert(_denom != 0);
      #endif
   }

   void reduce();
};

#endif
